"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var property_1 = require("./property");
/**
 * Member variable property declaration
 *
 * @export
 * @class VariableProperty
 * @extends {Property}
 */
var VariableProperty = (function (_super) {
    __extends(VariableProperty, _super);
    /**
     * Creates an instance of VariableProperty.
     * @param {string} identifier Variable identifier
     * @param {Accessibility} accessibility Member accessibility
     * @param {Type} type Type of the variableÎ
     *
     * @memberOf VariableProperty
     */
    function VariableProperty(identifier, accessibility, type, stereotype) {
        if (stereotype === void 0) { stereotype = 0 /* None */; }
        var _this = _super.call(this, identifier, accessibility, stereotype) || this;
        _this._type = type;
        return _this;
    }
    Object.defineProperty(VariableProperty.prototype, "type", {
        /**
         * Type of the variable
         *
         * @type {Type}
         * @memberOf VariableProperty
         */
        get: function () {
            return this._type;
        },
        set: function (value) {
            this._type = value;
        },
        enumerable: true,
        configurable: true
    });
    return VariableProperty;
}(property_1.Property));
exports.VariableProperty = VariableProperty;
