import * as Collections from "typescript-collections";
import { FunctionProperty } from "./functionProperty";
import { Node } from "./node";
import { Stereotype } from "./stereotype";
import { VariableProperty } from "./variableProperty";
export declare class Class extends Node {
    private _methods;
    private _variables;
    methods: Collections.Dictionary<string, FunctionProperty>;
    variables: Collections.Dictionary<string, VariableProperty>;
    constructor(identifier: string, stereotype?: Stereotype);
}
